#!/usr/bin/env perl

use strict;
use warnings;

use Test::More;
use Test::Moose::More;

use Person;

use Readonly;
Readonly my $CLASS => 'Person';

subtest "$CLASS is a well formed object" => sub {
    meta_ok( $CLASS );

    does_ok( $CLASS, 'Role::Exercise' );
};

subtest "$CLASS has the correct attributes" => sub {
    has_attribute_ok( $CLASS, 'first_name' );
    has_attribute_ok( $CLASS, 'last_name' );
    has_attribute_ok( $CLASS, 'birth_datetime' );
};

subtest "$CLASS has the correct methods" => sub {
    has_method_ok( $CLASS, 'age' );
};

done_testing;
