#!/usr/bin/env perl

use strict;
use warnings;

use Test::More;
use Test::Moose::More;

use Role::Exercise;

use Readonly;
Readonly my $ROLE => 'Role::Exercise';

subtest "$ROLE is a well formed role" => sub {
    is_role_ok( $ROLE );

    requires_method_ok( $ROLE, 'age' );
};

subtest "$ROLE has the correct attributes" => sub {
    has_attribute_ok( $ROLE, 'is_exercising' );
    has_attribute_ok( $ROLE, 'heart_rate' );
    has_attribute_ok( $ROLE, 'base_heart_rate' );
};

subtest "$ROLE has the correct builders" => sub {
    has_method_ok( $ROLE, '_build_heart_rate' );
    has_method_ok( $ROLE, '_build_base_heart_rate' );
};

subtest "$ROLE has the correct methods" => sub {
    has_method_ok( $ROLE, 'rest' );
    has_method_ok( $ROLE, 'walk' );
    has_method_ok( $ROLE, 'run' );
};

done_testing;
